<script setup lang="ts">
  import { required } from '@vuelidate/validators';
  import { useVuelidate } from '@vuelidate/core';
  import { SlideGroupItem } from 'logic/interfaces';

  type PositionOption = {
    id: string | null;
    label: string;
  };

  const emits = defineEmits<{
    (
      e: 'submit',
      payload: { name: string; currentPageGroupId: string | null; goToNewSlide: boolean },
    ): void;
  }>();

  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
  }>();

  const { t } = useI18n();
  const { currentSlide, slideGroupList } = usePresentation();

  const positionOptions = computed<PositionOption[]>(() => {
    if (!slideGroupList.value.length) return [];

    const options = slideGroupList.value.map((group: SlideGroupItem) => {
      return {
        id: group.id,
        label: `${t('after')} "${group.name}"`,
      };
    });

    return [
      {
        id: 'null',
        label: `${t('before')} "${slideGroupList.value[0].name}"`,
      },
      ...options,
    ];
  });

  const getCurSlideGroup = () => {
    const curGroupId = currentSlide.value?.groupId;
    return positionOptions.value.find((g) => g.id === curGroupId);
  };

  const DEFAULT_VALUE = {
    name: '',
    currentPageGroupId: getCurSlideGroup()?.id || null,
    goToNewSlide: true,
  };

  const state = reactive({
    ...DEFAULT_VALUE,
  });

  const rules = {
    name: {
      required,
    },
  };

  const $v = useVuelidate(rules, state);

  const onSubmit = async (e: Event) => {
    e.preventDefault();
    $v.value.$touch();
    const valid = await $v.value.$validate();

    if (valid) {
      const temp = { ...state };
      if (temp.currentPageGroupId === 'null') {
        temp.currentPageGroupId = null;
      }
      emits('submit', temp);
      props.controller.close();
    }
  };
</script>

<template>
  <SwModal backdrop-display="static" :controller="controller">
    <template #body>
      <div class="flex flex-col space-y-6">
        <div>
          <span class="text-lg/[1.625rem] font-bold">{{
            $t('listing.publishProductListingsModal.headline')
          }}</span>
          <p class="text-(sm/6 information) pt-2">
            {{ $t('listing.publishProductListingsModal.sublime') }}
          </p>
        </div>
        <div>
          <SwTextField
            id="name"
            v-model="state.name"
            size="large"
            :placeholder="$t('listing.publishProductListingsModal.namePlaceholder')"
            name="name"
            type="text"
            :label="$t('name')"
            :class="{
              '!border-crimson-500': $v.name?.$error,
            }"
          />
        </div>

        <div v-if="positionOptions.length">
          <SwSelect
            v-model="state.currentPageGroupId"
            :label="$t('position')"
            label-field="label"
            key-field="id"
            :options="positionOptions"
            size="large"
          />
        </div>

        <div v-if="positionOptions.length">
          <SwCheckbox v-model="state.goToNewSlide" class="focus:ring-none">
            <template #label>
              <span class="text-sm/6 font-semibold">
                {{ $t('listing.publishProductListingsModal.goToNewSlide') }}
              </span>
            </template>
            <template #meta>
              <span class="text-(xs information-subdued) font-medium">
                {{ $t('listing.publishProductListingsModal.goToNewSlideDesc') }}
              </span>
            </template>
          </SwCheckbox>
        </div>
      </div>
    </template>

    <template #footer>
      <SwButton size="large" variant="action" @click="props.controller.close">
        {{ $t('cancel') }}
      </SwButton>
      <SwButton size="large" @click="onSubmit">{{ $t('publish') }}</SwButton>
    </template>
  </SwModal>
</template>
